import { EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
/**
 * Angular Form Base Module
 */
export declare class FormBase<T> implements ControlValueAccessor {
    value: T;
    checked: boolean;
    private skipFromEvent;
    propagateChange(_: T): void;
    propagateTouch(): void;
    enabled: Object;
    private ngrValue;
    element: HTMLElement;
    inputElement: HTMLInputElement;
    private ngEle;
    appendTo: (ele: string | HTMLElement) => void;
    focus: EventEmitter<Object>;
    blur: EventEmitter<Object>;
    localChange(e: {
        value?: T;
        checked?: T;
    }): void;
    properties: Object;
    saveChanges: Function;
    registerOnChange(registerFunction: (_: T) => void): void;
    registerOnTouched(registerFunction: () => void): void;
    twoWaySetter(newVal: Object, prop: string): void;
    ngAfterViewInit(): void;
    setDisabledState(disabled: boolean): void;
    writeValue(value: T): void;
    ngOnFocus(e: Event): void;
    ngOnBlur(e: Event): void;
}
